const child_process = require("child_process"),
  os = require("os"),
  EventEmitter = require("events"),
  BdpTaskAdapter = require("../BdpTaskAdapter")

class BdpLocalAdapter extends BdpTaskAdapter {
  constructor(opt) {
    opt.adapterName = "Local";
    opt.adapterAuthor = "Chi Yang: chiyang1118@gmail.com";
    super(opt);
    this.userInfo = os.userInfo();
    this.options.stdoeMode = "pipe";
  }

  async processSpawn(taskID) {
    const taskEmitter = new EventEmitter();
    const taskObj = this.taskLogs[taskID];
    const RunningProcess = child_process.spawn(taskObj.exec, taskObj.args, {
      cwd: taskObj.option.cwd || this.options.cwd || process.cwd(),
      shell: true,
      env: process.env
    });
    RunningProcess.on("exit", (code, signal) => {
      return code == 0
        ? taskEmitter.emit("finish", 0, null)
        : taskEmitter.emit("error", code, signal);
    });
    return {
      jobID: RunningProcess.pid,
      stdoutStream: RunningProcess.stdout,
      stderrStream: RunningProcess.stderr,
      taskEmitter: taskEmitter
    };
  }
}
module.exports = BdpLocalAdapter;
