#!/bin/bash
SPARK_HOME=$1


MASTER=`head -1 $PBS_NODEFILE`;
PORT=7077
spark_master="spark://$MASTER:$PORT"

cleanUpAndExit() {
  #shutdown spark slave services
  for n in `uniq $PBS_NODEFILE`; do
  echo -n "stopting spark slave on $n..."
  if [ "$n" == "$MASTER" ]; then
  $SPARK_HOME/sbin/stop-slave.sh
  else
    ssh $n "$SPARK_HOME/sbin/stop-slave.sh";
  fi
  echo "done";
  done

  # shutdown spark master services
  echo -n "stopping spark master on $MASTER"
  $SPARK_HOME/sbin/stop-master.sh
}
#Trap SIGTERM SIGINT to allow gracefully sthutdown spark services and exit script abnormally
trap "cleanUpAndExit; rm -rf ~/spark.${PBS_JOBID}; exit 1;" SIGTERM SIGINT


echo -n "starting spark master on $MASTER... ";
$SPARK_HOME/sbin/start-master.sh
STATUS=$?
if [ "$STATUS" -gt "0" ]
  then
    echo $STATUS > ~/spark.${PBS_JOBID}
    echo "failed";
  else
    echo "done";
fi

sleep 2;
echo "spark cluster web interface: http://$MASTER:8080" 
echo "           spark master URL: spark://$MASTER:7077"

for n in `uniq $PBS_NODEFILE`; 
do
  echo -n "starting spark slave on $n..."
  if [ "$n" == "$MASTER" ]; then
    $SPARK_HOME/sbin/start-slave.sh $spark_master ; 
    STATUS=$?
  else
    ssh $n "$SPARK_HOME/sbin/start-slave.sh $spark_master" ; 
    STATUS=$?
  fi
  if [ "$STATUS" -gt "0" ]
    then
      echo $STATUS > ~/spark.${PBS_JOBID}
      echo "failed";
      break;
    else
      echo "done";
  fi
done


echo "0" > ~/spark.${PBS_JOBID}
echo $MASTER >> ~/spark.${PBS_JOBID}
while [ 1 ]
do
# check ~/spark.${PBS_JOBID}; if no file, exit while loop; else sleep 1m
if [ ! -f ~/spark.${PBS_JOBID} ]
then
break;
else   
  sleep 1m;
fi
done

cleanUpAndExit;
exit 0;
