module.exports = function (bytes, si, decimal) {
    const thresh = si ? 1024 : 1000;
    decimal = decimal == undefined ? 0 : decimal;
    if (Math.abs(bytes) < thresh) {
        return bytes + ' B';
    }
    const units = si
        ? ['Ki', 'Mi', 'Gi', 'Ti', 'Pi', 'Ei', 'Zi', 'Yi']
        : ['K', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y'];
    let u = -1;
    do {
        bytes /= thresh;
        ++u;
    } while (Math.abs(bytes) >= thresh && u < units.length - 1);
    return { value: bytes.toFixed(decimal), unit: units[u]};
}
