const path = require("path"),
  pathIsInside = require("path-is-inside");
module.exports = function(
  externalPath,
  externalRefPath,
  inContainerPathRef
) {
  let returnPath = '';
  if (externalRefPath == undefined) {
    externalRefPath = process.env.PROJECT_FOLDER;
  } else if (externalRefPath === 'project') {
    externalRefPath = process.env.PROJECT_FOLDER;
    inContainerPathRef = '/project/';
  } else if (externalRefPath === 'package') {
    externalRefPath = process.env.PACKAGE_FOLDER;
    inContainerPathRef = '/package/';
  }

  if (externalPath && externalRefPath) {
    externalPath = externalPath.replace(/\\ /g, " ");
    externalPath = path.normalize(path.resolve(externalPath));
    externalRefPath = externalRefPath.replace(/\\ /g, " ");
    externalRefPath = path.normalize(path.resolve(externalRefPath));
    const relativePath = path
      .relative(externalRefPath, externalPath)
      .split(path.sep)
      .join("/");
    if (!pathIsInside(externalPath, externalRefPath)) {
      if (!process.env.EXTERNAL_FOLDERS) {
        process.env.EXTERNAL_FOLDERS = externalPath;
      } else {
        process.env.EXTERNAL_FOLDERS += "," + externalPath;
      }
      returnPath = externalPath;
    } else {
      if (inContainerPathRef) {
        if (inContainerPathRef.match(/\/$/)) {
          returnPath = inContainerPathRef + relativePath;
        } else {
          returnPath = inContainerPathRef + "/" + relativePath;
        }
      } else {
        returnPath = "/project/" + relativePath;
      }
    }
  } else {
    if (externalRefPath === false) {
      returnPath = path.resolve(externalPath).replace(/\\ /g, " ").replace(/\\/g, '\\\\');
    }else {
      returnPath = path.resolve(externalRefPath).replace(/\\ /g, " ").replace(/\\/g, "\\\\");
    }
  }
  return returnPath.replace(/\\/g, '\\\\');
};
