const child_process = require('child_process');
module.exports = function(exec, args, processName){
    return new Promise((resolve, reject) => {
        process.stderr.write('[' + new Date().toString() + '] ' + processName + ' Starting.\n');
        process.stderr.write('[command] ' + exec + ' ' + args.join(' ') + '\n');
        const RunningProcess = child_process.spawn(exec, args, {cwd: process.cwd(), shell: true});
        RunningProcess.stderr.on('data', (data) => {
            process.stderr.write(data);
        });
        RunningProcess.stdout.on('data', (data) => {
            process.stdout.write(data);
        });
        RunningProcess.on('error', (err) => {
            process.stderr.write('[' + new Date().toString() + '] ' + processName + ' has errors.\n');
            process.stderr.write(JSON.stringify(err));
            reject(processName + ' failed.');
        });
        RunningProcess.on('exit', (code) => {
            process.stderr.write('[' + new Date().toString() + '] ' + processName + ' Finished.\n');
            if (!code) {
                resolve(processName + ' Finished.');
            }else {
                reject(processName + ' failed.');
            }
        });
        RunningProcess.on('SIGTERM', () => {
            RunningProcess.kill();
        });
        RunningProcess.on('SIGINT', () => {
            RunningProcess.kill();
        });
    });
}
